// PICUpdaterDlg.cpp : implementation file
//

#include "stdafx.h"
#include "PICUpdater.h"
#include "PICUpdaterDlg.h"

#define MAX_ROM_PAGES 21

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CPICUpdaterDlg dialog




CPICUpdaterDlg::CPICUpdaterDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPICUpdaterDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPICUpdaterDlg::DoDataExchange(CDataExchange* pDX) {
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CPICUpdaterDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
   ON_BN_CLICKED(IDC_UPDATE, &CPICUpdaterDlg::OnBnClickedUpdate)
   ON_BN_CLICKED(IDC_BROWSE, &CPICUpdaterDlg::OnBnClickedBrowse)
END_MESSAGE_MAP()


// CPICUpdaterDlg message handlers

BOOL CPICUpdaterDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

  //Get the dialog controls
   eFilename = (CEdit*)GetDlgItem(IDC_FILENAME);
   pbProgress = (CProgressCtrl*)GetDlgItem(IDC_PROGRESS);
   cbComPort = (CComboBox*)GetDlgItem(IDC_COMPORT);
   bUpdate = (CButton*)GetDlgItem(IDC_UPDATE);
   
  //Set text box text to "<none>"
   eFilename->SetWindowText(_T("<none>"));

  //Disable the update button (no file)
   bUpdate->EnableWindow(FALSE);

  //Fill the COM Port dropdown with ports
   char dosdevicelist[65536];
   int nchars = QueryDosDevice(NULL,dosdevicelist,65535);
   //for(int i = 0; i < 65536; i++) if(dosdevicelist[i]==0) dosdevicelist[i]=' ';

   char* dev = dosdevicelist;
   int position = 0;
   while(position < nchars) {
      if(!strncmp(dev,"COM",3)) {
         cbComPort->AddString(dev);
      }
      position += strlen(dev) + 1;
      dev += strlen(dev) + 1;
   }
   cbComPort->SetCurSel(0);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CPICUpdaterDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPICUpdaterDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CPICUpdaterDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CPICUpdaterDlg::OnBnClickedUpdate() {
   bUpdate->EnableWindow(FALSE);
   rom_page rom[MAX_ROM_PAGES];
   memset(rom,0,sizeof(rom_page)*MAX_ROM_PAGES);
   if(ReadImage(rom))
      WriteFlash(rom);
   bUpdate->EnableWindow(TRUE);
}

unsigned long parsehex(char* c, int n) {
   unsigned long result = 0;
   for(int i = n-1; i>=0; i--) {
      result <<= 8;

      unsigned char digit = c[i*2] - '0';
      if(digit > 9) digit = c[i*2] - 'A' + 10;
      if(digit > 15) digit = c[i*2] - 'a' + 10;
      unsigned char byte = digit << 4;

      digit = c[i*2+1] - '0';
      if(digit > 9) digit = c[i*2+1] - 'A' + 10;
      if(digit > 15) digit = c[i*2+1] - 'a' + 10;
      byte |= digit & 0xF;

      result |= byte;
   }
   return result;
}

int CPICUpdaterDlg::ReadImage(rom_page* rom) {
  //Initialize the ROM
   for(int i = 0; i < MAX_ROM_PAGES; i++) {
      rom[i].nlines = 0;
      memset(rom[i].data,0xFF,3072);
   }

   CString filename;
   eFilename->GetWindowText(filename);

   char buffer[65536];

   FILE* f = NULL;
   fopen_s(&f,filename,"r");
   if(!f) {
      MessageBox("Error: Could not open file");
      return 0;
   }

   int ext_address = 0;

   while(!feof(f)) {
     //Read a line
      fgets(buffer,65535,f);
      
     //Parse the line
      if(strlen(buffer) < 12) continue;
      if(buffer[0] != ':') continue;

      int nbytes = parsehex(buffer+1,1);
      int address = ((parsehex(buffer+3,1)<<8)|parsehex(buffer+5,1));  //Address is big-endian
      int type = parsehex(buffer+7,1);

      if(type == 1) break;
	  if(type == 4 && nbytes == 2) {
	     ext_address = ((parsehex(buffer+9,1)<<8)|parsehex(buffer+11,1));
	     continue;
	  }
      if(type != 0) continue;
      if(nbytes%4) {
         MessageBox("Malformed file");
         fclose(f);
		 return FALSE;
      }

	  address |= (ext_address << 16);
	  address *= 3;
	  address /= 4;

      for(int i = 0; i < nbytes/4; i++) {
         int addr = address+i*3;

         int page = addr/3072;
         if(page < 0 || page > 20) continue;

         int offset = addr%3072;
         int row = offset / 192;
         if(rom[page].nlines < row+1) rom[page].nlines = row+1;

         unsigned long dataword = parsehex(buffer+9+i*8,4);                  //Data is little-endian
         rom[page].data[offset]   = (unsigned char)(dataword&0xFF);
         rom[page].data[offset+1] = (unsigned char)((dataword&0xFF00)>>8);
         rom[page].data[offset+2] = (unsigned char)((dataword&0xFF0000)>>16);
      }
   }

   fclose(f);

   return TRUE;

}

void CPICUpdaterDlg::WriteFlash(rom_page* rom) {
   CString portname;
   cbComPort->GetWindowText(portname);

   pbProgress->SetPos(0);
   pbProgress->SetRange(0,MAX_ROM_PAGES);

   portname = CString("\\\\.\\")+portname;
  
  //Open the COM port
   HANDLE f = CreateFile(portname, GENERIC_READ|GENERIC_WRITE, 0, NULL, OPEN_EXISTING, NULL, NULL);
   if(f==INVALID_HANDLE_VALUE) {
      MessageBox("Error: Could not open COM port");
      return;
   }

  //Set for 115200/8/N/1/N
   DCB com_dcb;
   memset(&com_dcb,0,sizeof(DCB));
   com_dcb.DCBlength = sizeof(DCB);
   com_dcb.BaudRate = CBR_115200;
   com_dcb.fBinary = TRUE;
   com_dcb.ByteSize = 8;
   SetCommState(f,&com_dcb);

   COMMTIMEOUTS cto;
   cto.ReadIntervalTimeout = 0;
   cto.ReadTotalTimeoutMultiplier = 2000;
   cto.ReadTotalTimeoutConstant = 2000;
   cto.WriteTotalTimeoutConstant = 100;
   cto.WriteTotalTimeoutMultiplier = 100;
   SetCommTimeouts(f,&cto);

   unsigned long nbytes = 0;
   char response = 0;
   int attempts = 0;

  //Write the command to enter flash and wait 200ms
   PurgeComm(f,PURGE_RXCLEAR);
   WriteFile(f,"\x80",1,&nbytes,NULL);

  //Wait for the magic boot code
   response = 0;
   bool good = false;
   DWORD code = 0;
   for(int i = 0; i < 2; ++i) {
	   ReadFile(f,&response,1,&nbytes,NULL);
	   code = (BYTE)response;
	   if(code != 0) break;
   }
   if(response == 2) {
	   ReadFile(f,&response,1,&nbytes,NULL);
	   code |= ((DWORD)((BYTE)response)) << 8;
	   if(response == 15) {
		   ReadFile(f,&response,1,&nbytes,NULL);
		   code |= ((DWORD)((BYTE)response)) << 16;
		   if(response == 15) {
			   ReadFile(f,&response,1,&nbytes,NULL);
			   code |= ((DWORD)((BYTE)response)) << 24;
			   if(response == 20) {
				   good = true;
			   }
		   }
	   }
   }
   if(!good) {
	   CString s; s.Format("0x%08x",code);
      MessageBox("Error: No magic boot code received. " + s);
	  CloseHandle(f);
      return;
   }

   WriteFile(f,"\x06\x18\x06\x13",4,&nbytes,NULL);

	//Receive the ACK/NAK
	 ReadFile(f,&response,1,&nbytes,NULL);
	 TRACE1("Magic Response: 0x%x",response);
   
  //Write each page
   for(int i = 0; i < MAX_ROM_PAGES; i++) {

    TRACE1("Attempting to write page %i...\n",i);

      attempts = 0;
      while(attempts < 5) {

         TRACE1(" Attempt %i: ",attempts+1);

         response = 0;
         PurgeComm(f,PURGE_RXCLEAR);
       
        //Write the number of ROM rows to program
         WriteFile(f,&rom[i].nlines,1,&nbytes,NULL);

	    //Receive the ACK/NAK
		 ReadFile(f,&response,1,&nbytes,NULL);
		 if(response == '*') {

			 TRACE0("[count]");

			//Write the data
			 WriteFile(f,rom[i].data,rom[i].nlines*192,&nbytes,NULL);

			 TRACE1("[data (%d)]",nbytes);

			//Write the checksum
			 unsigned char checksum = 0;
			 for(int j = 0; j < rom[i].nlines*192; j++) {
				checksum += rom[i].data[j];
			 }
			 checksum = -checksum;
			 WriteFile(f,&checksum,1,&nbytes,NULL);

			 TRACE1("[checksum (%x)]",checksum);

			//Check the response
			 response = 0;
			 ReadFile(f,&response,1,&nbytes,NULL);

			 if(response == '*') break;

		 }
	     TRACE1(" Failed: %x\n",response);

         Sleep(200); attempts++;
      }
      if(attempts>=5) {
         CloseHandle(f);
         CString err; err.Format("Error: Failed to write page %i",i);
         MessageBox(err);
         return;
      }

      TRACE0(" Success\n");

      pbProgress->SetPos(i+1);
   }

   CloseHandle(f);

   MessageBox("Firmware update successful");
   pbProgress->SetPos(0);
}

void CPICUpdaterDlg::OnBnClickedBrowse() {
   CFileDialog fd(TRUE,".hex",NULL,OFN_HIDEREADONLY | OFN_FILEMUSTEXIST,
                  "Firmware image files (*.hex)|*.hex|All files (*.*)|*.*||",this,0,0);
   if(fd.DoModal()) {
      eFilename->SetWindowText(fd.GetPathName());
      bUpdate->EnableWindow();
   }
}
